import Chisel._

class AsyncFifoProblem extends Module {
  val io = new Bundle { val out = Decoupled(UInt(width=8)) }
  val in_clock = clock * 2
  val fifo = Module (new AsyncFifo(UInt(width=8), 10, in_clock, clock))
  fifo.io.enq.bits  := UInt(1)
  fifo.io.enq.valid := Bool(true)
  io.out <> fifo.io.deq
}

object AsyncFifoProblem {
  def main(args: Array[String]) {
    chiselMain(Array("--backend", "c", "--compile"), () => Module(new AsyncFifoProblem))
  }
}
